import { DependencyFactory, DependencyInformation, FactoryOption, Key, NormalConstructor } from '../ServiceCollection';
import { ScopedServiceProvider } from '../ServiceProvider';
import { ILifetime } from './ILifetime';
export declare class SingletonLifetime<T, E> implements ILifetime<T, E> {
    private readonly factory;
    readonly isSingleton = true;
    readonly name: Key<E>;
    constructor(name: Key<E>, factory: DependencyFactory<T, void, E>);
    provide(context: ScopedServiceProvider<E>): any;
    clone(): ILifetime<T, E>;
}
export declare function singleton<T, E>(dep: FactoryOption<T, void, E> | NormalConstructor<T, E>): DependencyInformation<T, E>;
