import { ILifetime } from '../Lifetime';
import { IServiceProvider } from '../ServiceProvider';
import { MockStrategy, ProviderMock } from './mockUtils';
import { DependencyMap, Selector } from './types';
export declare class ServiceCollection<E = {}> {
    private readonly self;
    private readonly lifetimes;
    constructor();
    addMethod<F>(func: (services: ServiceCollection<E>) => ServiceCollection<F>): ServiceCollection<F>;
    add<KT, F extends DependencyMap<E, KT>>(dependencies: F & DependencyMap<E, KT>): ServiceCollection<{ [key in keyof KT | keyof E]: key extends keyof E ? E[key] : key extends keyof KT ? KT[key] : never; }>;
    get<T>(selector: Selector<T, E>): ILifetime<T, E> | undefined;
    remove<T, K extends string>(selector: Selector<T, E>): ServiceCollection<(Omit<E, K> extends infer T_2 ? { [key_1 in keyof T_2]: key_1 extends keyof E ? E[key_1] : T; } : never) extends infer T_1 ? { [key in keyof T_1]: (Omit<E, K> extends infer T_2 ? { [key_1 in keyof T_2]: key_1 extends keyof E ? E[key_1] : T; } : never)[key]; } : never>;
    build(): IServiceProvider<E>;
    buildMock(mock?: MockStrategy | ProviderMock<E>, defaultMockType?: MockStrategy): IServiceProvider<E>;
}
